module Scrubyt
  ##
  #=<tt>Utilities shared between the other utility classes (XPathUtils, SimpleExampleLookup,...)</tt>  
  #  
  class SharedUtils
    #When looking up examples, do NOT recurse into these tags since they won't contain any usable info
    NON_CONTENT_TAGS = ['form','option', 'input', 'script', 'noscript']
    
    #Entities to replace - need to make this more complete, or install htmlentities or similar package
    ENTITIES = {
        'quot'      => '"',
        'apos'      => "'",
        'amp'       => '&',
        'lt'        => '<',
        'gt'        => '>',
        'nbsp'      => ' '}
    
    #Unescape the entities in the HTML!
    def self.unescape_entities(text)
        ENTITIES.each {|e,s| text.gsub!(/\&#{e};/) {"#{s}"} }
        text
    end  
    
    #Entry point for finding the elements specified by examples
    def self.traverse_for_match(node, regexp)
      @results = []
      traverse_for_match_inner(node,regexp)
      @results 
    end
    
private
    def self.traverse_for_match_inner(node, regexp)
      ft = unescape_entities(node.inner_text).strip 
      if ((ft =~ regexp) && (node.is_a? Hpricot::Elem))
        @results << node 
        @results.delete node.parent
      end
      node.children.each do |child|
        if child.instance_of? Hpricot::Elem
          traverse_for_match_inner(child, regexp) unless NON_CONTENT_TAGS.include? child.name
        end
      end          
    end #end of method traverse_for_match    
  end #end of class SharedUtils
end #end of module Scrubyt
